## limesuite 18.06.0+dfsg

=== CMakeLists.txt ===
########################################################################
## Create lime-suite project
########################################################################
cmake_minimum_required(VERSION 3.1.3)
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE TYPE INTERNAL FORCE)
project("LimeSuite")

option(BUILD_SHARED_LIBS "Build the shared library" ON)

#include modules for finding CyAPI
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

cmake_policy(SET CMP0015 OLD)
if(${CMAKE_MAJOR_VERSION} GREATER 2)
    cmake_policy(SET CMP0043 NEW)
endif()

list(FIND CMAKE_CONFIGURATION_TYPES "${CMAKE_BUILD_TYPE}" index)
if (${index} EQUAL -1)
   set(CMAKE_BUILD_TYPE "Release")
endif()

########################################################################
# Gather version information from the changelog
# LIME_SUITE_API_VERSION in VersionInfo.h reflects the major/minor
########################################################################
file(READ "${PROJECT_SOURCE_DIR}/Changelog.txt" changelog_txt)
string(REGEX MATCH "Release ([0-9]+)\\.([0-9]+)\\.([0-9]+) \\(" CHANGELOG_MATCH "${changelog_txt}")
if(NOT CHANGELOG_MATCH)
    message(FATAL_ERROR "Failed to extract version number from Changelog.txt")
endif(NOT CHANGELOG_MATCH)
set(VERSION_MAJOR "${CMAKE_MATCH_1}")
set(VERSION_MINOR "${CMAKE_MATCH_2}")
set(VERSION_PATCH "${CMAKE_MATCH_3}")

# the ABI compatibility number should be incremented when the ABI changes
# the format is to use the same major and minor, but to have an incrementing
# number if there are changes within the major.minor release series
set(LIME_SUITE_SOVER "${VERSION_MAJOR}.${VERSION_MINOR}-1")

# packagers may specify -DLIME_SUITE_EXTVER="foo" to replace the git hash
if (NOT LIME_SUITE_EXTVER)
    include(${PROJECT_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake)
    get_git_head_revision(GITREFSPEC GITHASH)
    if (GITHASH)
        string(SUBSTRING "${GITHASH}" 0 8 GITHASH)
        set(LIME_SUITE_EXTVER "g${GITHASH}")
    else (GITHASH)
        set(LIME_SUITE_EXTVER "unknown")
    endif (GITHASH)
endif()

set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
set(LIME_SUITE_VERSION "${LIME_SUITE_LIBVER}-${LIME_SUITE_EXTVER}")
string(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d")

#LIME_SUITE_ROOT is compiled into the library to locate the install base.
#By default, the LIME_SUITE_ROOT is set to the CMAKE_INSTALL_PREFIX.
#However users may overload this by specifying -DLIME_SUITE_ROOT=<path>.
set(LIME_SUITE_ROOT "${CMAKE_INSTALL_PREFIX}" CACHE PATH
    "Installation root for lime::getLimeSuiteRoot()")
file(TO_CMAKE_PATH "${LIME_SUITE_ROOT}" LIME_SUITE_ROOT)

########################################################################
## compiler flags
########################################################################

#C++11 is a required language feature for this project
set(CMAKE_CXX_STANDARD 11)

#is this processor x86? set variable X86
if(CMAKE_SYSTEM_PROCESSOR MATCHES "i686.*|i386.*|x86.*|amd64.*|AMD64.*")
    set(X86 TRUE)
else()
    set(X86 FALSE)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)

    #enable C++11 on older versions of cmake
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()

    #enable warnings in Debug configurations
    if (NOT CMAKE_BUILD_TYPE STREQUAL "Release")
    	add_compile_options(-Wall -Wpedantic)
    endif()

    #symbols are only exported from libraries/modules explicitly
    add_compile_options(-fvisibility=hidden)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")

    #default SIMD configuration uses native build flags
    #when packaging and x86, use sse3 so the binaries work across multiple x86 variants
    set(DEFAULT_SIMD_FLAGS "native")
    if ("${CMAKE_INSTALL_PREFIX}" STREQUAL "/usr" AND X86)
        set(DEFAULT_SIMD_FLAGS "SSE3")
    endif()

    SET(ENABLE_SIMD_FLAGS "${DEFAULT_SIMD_FLAGS}" CACHE STRING "Set compiler SIMD flags")
    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none native SSE3 SSE4.2 AVX AVX2) 

    if(${ENABLE_SIMD_FLAGS} MATCHES "native")
        add_definitions(-march=native)
        if(X86)
            add_definitions(-mfpmath=both)
        endif()
        message(STATUS "Enabling native optimizations")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfma -mavx2 -mfpmath=both)
        message(STATUS "Enabling AVX2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mavx -mfpmath=both)
        message(STATUS "Enabling AVX instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE4.2")
        add_definitions(-mmmx -msse -msse2 -msse3 -mssse3 -msse4.1 -msse4.2 -mpopcnt -mfpmath=both)
        message(STATUS "Enabling SSE4.2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE3")
        add_definitions(-mmmx -msse -msse2 -msse3 -mfpmath=both)
        message(STATUS "Enabling SSE3 instructions")
    endif()

endif()

if (MSVC)
    include_directories(${PROJECT_SOURCE_DIR}/external/msvc)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set( MSVC_MULTITHREAD_COMPILE_FLAGS "/MP")
    set( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${MSVC_MULTITHREAD_COMPILE_FLAGS}" )

    SET(ENABLE_SIMD_FLAGS "SSE2" CACHE STRING "Set compiler SIMD flags")
    SET_PROPERTY(CACHE ENABLE_SIMD_FLAGS PROPERTY STRINGS none SSE2 AVX AVX2) 

    if(${ENABLE_SIMD_FLAGS} MATCHES "AVX2")
        add_definitions(/arch:AVX2)
        message(STATUS "Enabling AVX2 instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "AVX")
        add_definitions(/arch:AVX)
        message(STATUS "Enabling AVX instructions")
    elseif(${ENABLE_SIMD_FLAGS} MATCHES "SSE2")
        add_definitions(/arch:SSE2)
        message(STATUS "Enabling SSE2 instructions")
    endif()
endif(MSVC)

if (APPLE)
   add_definitions(-D__unix__=1) #we use this for unix detection, but clang does not define it
endif(APPLE)

########################################################################
# rpath setup - http://www.cmake.org/Wiki/CMake_RPATH_handling
########################################################################
# use, i.e. don't skip the full RPATH for the build tree
option(CMAKE_SKIP_BUILD_RPATH "skip rpath build" FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
option(CMAKE_BUILD_WITH_INSTALL_RPATH "build with install rpath" FALSE)

# the RPATH to be used when installing, but only if it's not a system directory
option(CMAKE_AUTOSET_INSTALL_RPATH TRUE)
if(CMAKE_AUTOSET_INSTALL_RPATH)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ENDIF("${isSystemDir}" STREQUAL "-1")
endif(CMAKE_AUTOSET_INSTALL_RPATH)

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "build with automatic rpath" TRUE)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
endif()

########################################################################
## lime suite build
########################################################################
add_subdirectory(src)
add_subdirectory(mcu_program)
add_subdirectory(LimeUtil)
add_subdirectory(QuickTest)

########################################################################
## SoapySDR bindings for LMS7 RFIC driver
########################################################################
add_subdirectory(SoapyLMS7)

########################################################################
## udev rules for linux usb
########################################################################
if (DEFINED UDEV_RULES_PATH)
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/udev-rules/64-limesuite.rules
        DESTINATION ${UDEV_RULES_PATH})
endif()

########################################################################
## Doxygen
########################################################################
find_package(Doxygen QUIET)
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_API_DOXYGEN "Enable LMS API Doxygen documentation" ON "DOXYGEN_FOUND" OFF)
add_feature_info(LimeSuiteDocAPI ENABLE_API_DOXYGEN "LMS API Doxygen documentation")
if (ENABLE_API_DOXYGEN)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/DoxyfileAPI.in ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile @ONLY)
  add_custom_target(docAPI ALL
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/doc/Doxyfile 
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating LMS API documentation with Doxygen" VERBATIM
    )
endif()

if(DOXYGEN_FOUND)
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
  add_custom_target(doc
    ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile 
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMENT "Generating documentation with Doxygen" VERBATIM
    )
endif()

########################################################################
# CMake Project config files
########################################################################
if (ENABLE_HEADERS AND ENABLE_LIBRARY)
    configure_file(
        ${PROJECT_SOURCE_DIR}/cmake/Modules/LimeSuiteConfigVersion.in.cmake
        ${PROJECT_BINARY_DIR}/LimeSuiteConfigVersion.cmake
    @ONLY)

    install(FILES
        ${PROJECT_SOURCE_DIR}/cmake/Modules/LimeSuiteConfig.cmake
        ${PROJECT_BINARY_DIR}/LimeSuiteConfigVersion.cmake
        DESTINATION lib${LIB_SUFFIX}/cmake/${PROJECT_NAME})
endif (ENABLE_HEADERS AND ENABLE_LIBRARY)

########################################################################
## freedesktop environment integration
########################################################################
add_subdirectory(Desktop)

#########################################################################
# summary
#########################################################################
include(FeatureSummary)
message(STATUS "")
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} enabled features")
message(STATUS "######################################################")
feature_summary(WHAT ENABLED_FEATURES)
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} disabled features")
message(STATUS "######################################################")
feature_summary(WHAT DISABLED_FEATURES)
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Build timestamp: ${BUILD_TIMESTAMP}")
message(STATUS "Lime Suite version: ${LIME_SUITE_VERSION}")
message(STATUS "ABI/so version: ${LIME_SUITE_SOVER}")
include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/DownloadImages.cmake)

########################################################################
# uninstall target
########################################################################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

#only add uninstall target if this is the top project
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== QuickTest/CMakeLists.txt ===

#find FLTK
set(FLTK_SKIP_FLUID true)
find_package(FLTK)
execute_process(COMMAND fltk-config --ldflags OUTPUT_VARIABLE FLTK_LDFLAGS OUTPUT_STRIP_TRAILING_WHITESPACE)

cmake_dependent_option(ENABLE_QUICKTEST "LimeSDR quick test utility" ON "ENABLE_LIBRARY;FLTK_FOUND" OFF)
add_feature_info(LimeQuickTest ENABLE_QUICKTEST "LimeSDR-QuickTest Utility")

if(ENABLE_QUICKTEST)
    include_directories(${FLTK_INCLUDE_DIR})
    add_executable(LimeQuickTest
		   LimeSDRTest.cpp
		   LimeSDRTest_Mini.cpp
		   LimeSDRTest_USB.cpp
        	   TestGUI.cpp
		   resources/resource.rc
		   ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c)
    target_link_libraries(LimeQuickTest
		      LimeSuite
		      ${FLTK_LDFLAGS}
		      ${FLTK_LIBRARIES}
		      ${GLUT_LIBRARY}
		      )
    install(TARGETS LimeQuickTest DESTINATION bin)
endif()

=== octave/Makefile ===
# Makefile for Octave extension LimeSuite
SHELL := /bin/bash

.phony: all
all: LimeSuite.oct

.phony: clean
clean:
	rm -f LimeSuite.oct *.o

.phony: distclean
distclean: clean
	rm -f *~ octave-core core

.phony: test
test: LimeSuite_oct.oct
	octave --silent LimeInitialize.m

%.oct: %.cc	
#-LD:/projects/lms7suite/octave
	mkoctfile -v -I/usr/local/include/lime -L. -lLimeSuite $<

=== src/CMakeLists.txt ===
########################################################################
## public headers
########################################################################
set(LIME_SUITE_PUBLIC_HEADERS
    lime/LimeSuite.h
    VersionInfo.h
    Logger.h
    SystemResources.h
    LimeSuiteConfig.h
    ADF4002/ADF4002.h
    lms7002m_mcu/MCU_BD.h
    lms7002m_mcu/MCU_File.h
    ConnectionRegistry/IConnection.h
    ConnectionRegistry/ConnectionHandle.h
    ConnectionRegistry/ConnectionRegistry.h
    lms7002m/LMS7002M.h
    lms7002m/LMS7002M_RegistersMap.h
    lime/LMS7002M_parameters.h
    protocols/Streamer.h
    protocols/ADCUnits.h
    protocols/LMS64CCommands.h
    protocols/LMS64CProtocol.h
    protocols/LMSBoards.h
    protocols/dataTypes.h
    protocols/fifo.h
    Si5351C/Si5351C.h
    FPGA_common/FPGA_common.h
    API/lms7_device.h
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_HEADERS "Enable install headers" ON "TRUE" OFF)
add_feature_info(LimeSuiteHeaders ENABLE_HEADERS "The lime suite headers")
if (ENABLE_HEADERS)
    install(
        FILES ${LIME_SUITE_PUBLIC_HEADERS}
        DESTINATION include/lime
    )
endif()

########################################################################
## lime suite library
########################################################################
set(LIME_SUITE_SOURCES
    Logger.cpp
    ADF4002/ADF4002.cpp
    lms7002m_mcu/MCU_BD.cpp
    ConnectionRegistry/IConnection.cpp
    ConnectionRegistry/ConnectionHandle.cpp
    ConnectionRegistry/ConnectionRegistry.cpp
    lms7002m/LMS7002M_RegistersMap.cpp
    lms7002m/LMS7002M_parameters.cpp
    lms7002m/LMS7002M.cpp
    lms7002m/LMS7002M_RxTxCalibrations.cpp
    lms7002m/LMS7002M_BaseCalibrations.cpp
    lms7002m/goert.cpp
    lms7002m/mcu_dc_iq_calibration.cpp
    lms7002m/LMS7002M_filtersCalibration.cpp
    lms7002m/LMS7002M_gainCalibrations.cpp
    protocols/LMS64CProtocol.cpp
    protocols/Streamer.cpp
    protocols/ConnectionImages.cpp
    Si5351C/Si5351C.cpp
    ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c
    API/lms7_api.cpp
    API/lms7_device.cpp
    API/LmsGeneric.cpp
    API/qLimeSDR.cpp
    API/LimeSDR_mini.cpp
    API/LimeSDR.cpp
    FPGA_common/FPGA_common.cpp
    FPGA_common/FPGA_Mini.cpp
    FPGA_common/FPGA_Q.cpp
    windowFunction.cpp
)

set(LIME_SUITE_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}
    API
    lime
    GFIR
    protocols
    ConnectionRegistry
    lms7002m_mcu
    ADF4002
    Si5351C
    lms7002m
    LTEpackets
    FPGA_common
    lms7002m_mcu
    ${PROJECT_SOURCE_DIR}/external/cpp-feather-ini-parser
    HPM7
    ${PROJECT_SOURCE_DIR}/external/kissFFT/
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/VersionInfo.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/SystemResources.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/SystemResources.cpp)

if(CMAKE_COMPILER_IS_GNUCXX)
    list(APPEND LIME_SUITE_LIBRARIES -pthread)
endif(CMAKE_COMPILER_IS_GNUCXX)

include(FeatureSummary)
include(CMakeDependentOption)
option(ENABLE_LIBRARY "Enable build library" ON)
add_feature_info(LimeSuiteLibrary ENABLE_LIBRARY "The lime suite library")
if (ENABLE_LIBRARY)
    add_library(LimeSuite ${LIME_SUITE_SOURCES})
    target_link_libraries(LimeSuite ${LIME_SUITE_LIBRARIES})
    set_property(TARGET LimeSuite PROPERTY POSITION_INDEPENDENT_CODE TRUE)
    set_target_properties(LimeSuite PROPERTIES SOVERSION ${LIME_SUITE_SOVER})
    set_target_properties(LimeSuite PROPERTIES VERSION ${LIME_SUITE_LIBVER})
    set_target_properties(LimeSuite PROPERTIES DEFINE_SYMBOL "LIME_DLL_EXPORTS")
    target_include_directories(LimeSuite PUBLIC ${LIME_SUITE_INCLUDES})
    if(BUILD_SHARED_LIBS)
        target_compile_definitions(LimeSuite PUBLIC "LIME_DLL")
    endif()

    install(TARGETS LimeSuite
        LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
        ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
        RUNTIME DESTINATION bin              # .dll file
    )

	if (MSVC)
		set_target_properties(LimeSuite PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
	endif(MSVC)

    add_subdirectory(GFIR)
    set(LIME_SUITE_LIBS LimeSuite)
endif()

########################################################################
## Supported connections
########################################################################
include(ConnectionEVB7COM/CMakeLists.txt)
include(ConnectionFX3/CMakeLists.txt)
include(ConnectionSTREAM_UNITE/CMakeLists.txt)
#include(ConnectionNovenaRF7/CMakeLists.txt)
include(ConnectionFTDI/CMakeLists.txt)
include(ConnectionXillybus/CMakeLists.txt)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRegistry/BuiltinConnections.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp
)

target_sources(LimeSuite PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp)

########################################################################
## wx widgets dependency
########################################################################
set(wxWidgets_USE_DEBUG OFF)
set(wxWidgets_USE_UNICODE ON)
set(wxWidgets_USE_UNIVERSAL OFF)
set(wxWidgets_USE_STATIC ON)
find_package(wxWidgets COMPONENTS richtext xml html xrc adv aui core base gl)
message(STATUS "wxWidgets_DEFINITIONS: ${wxWidgets_DEFINITIONS}")
message(STATUS "wxWidgets_INCLUDE_DIRS: ${wxWidgets_INCLUDE_DIRS}")
message(STATUS "wxWidgets_LIBRARIES: ${wxWidgets_LIBRARIES}")

########################################################################
## LimeSuite GUI app
########################################################################
set(LMS7SUITE_GUI_SOURCES
    ADF4002/ADF4002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlXBUF_view.cpp
    lms7002_wxgui/lms7002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlRFE_view.cpp
    lms7002_wxgui/lms7002_pnlCalibrations_view.cpp
    lms7002_wxgui/lms7002_pnlTRF_view.cpp
    lms7002_wxgui/lms7002_pnlCDS_view.cpp
    lms7002_wxgui/lms7002_pnlLimeLightPAD_view.cpp
    lms7002_wxgui/lms7002_pnlBIST_view.cpp
    lms7002_wxgui/dlgViewIRAM.cpp
    lms7002_wxgui/lms7002_gui_utilities.cpp
    lms7002_wxgui/lms7002_pnlSX_view.cpp
    lms7002_wxgui/lms7002_pnlTBB_view.cpp
    lms7002_wxgui/lms7002_dlgVCOfrequencies.cpp
    lms7002_wxgui/lms7002_pnlRBB_view.cpp
    lms7002_wxgui/lms7002_pnlLDO_view.cpp
    lms7002_wxgui/lms7002_pnlAFE_view.cpp
    lms7002_wxgui/lms7002_pnlGains_view.cpp
    lms7002_wxgui/CoefficientFileParser.cpp
    lms7002_wxgui/lms7002_pnlRxTSP_view.cpp
    lms7002_wxgui/lms7002_mainPanel.cpp
    lms7002_wxgui/pnlBoardControls.cpp
    lms7002_wxgui/dlgViewSFR.cpp
    lms7002_wxgui/lms7002_pnlCLKGEN_view.cpp
    lms7002_wxgui/lms7002_pnlMCU_BD_view.cpp
    lms7002_wxgui/lms7002_pnlBIAS_view.cpp
    lms7002_wxgui/lms7002_dlgGFIR_Coefficients.cpp
    lms7002_wxgui/lms7002_pnlTxTSP_view.cpp
    lms7002_wxgui/lms7002_pnlR3.cpp
    LMS_Programing/LMS_Programing_wxgui.cpp
    utilities_gui/dlgConnectionSettings.cpp
    utilities_gui/pnlMiniLog.cpp
    utilities_gui/SPI_wxgui.cpp
    utilities_gui/dlgFullMessageLog.cpp
    utilities_gui/dlgDeviceInfo.cpp
    utilities_gui/utilities_gui.cpp
    lms7suiteAppFrame.cpp
    boards_wxgui/lms7002m_novena_wxgui.cpp
    RFSpark/RFSpark_wxgui.cpp
    Si5351C/Si5351C_wxgui.cpp
    lms7suiteApp_gui.cpp
    lms7suiteApp.cpp
    FPGAcontrols_wxgui/FPGAcontrols_wxgui.cpp
    HPM7/HPM7_wxgui.cpp
    dlgAbout.cpp
    numericSlider/numericSlider.cpp
    myriad7/myriad7_wxgui.cpp
    fftviewer_wxgui/fftviewer_wxgui.cpp
    fftviewer_wxgui/fftviewer_frFFTviewer.cpp
    lms7suiteEvents/lms7suiteEvents.cpp
    boards_wxgui/pnlQSpark.cpp
    boards_wxgui/pnluLimeSDR.cpp
    boards_wxgui/pnlUltimateEVB.cpp
    boards_wxgui/pnlBuffers.cpp
    ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c
    windowFunction.cpp
    boards_wxgui/pnlLimeSDR.cpp
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_GUI "Enable build GUI" ON "ENABLE_LIBRARY;wxWidgets_FOUND" OFF)
add_feature_info(LimeSuiteGUI ENABLE_GUI "GUI Application for LimeSuite")
if (ENABLE_GUI)

    include_directories(lms7002_wxgui)
    include_directories(LMS_Programing)
    include_directories(utilities_gui)
    include_directories(RFSpark)
    include_directories(FPGAcontrols_wxgui)
    include_directories(numericSlider)
    include_directories(myriad7)
    include_directories(fftviewer_wxgui)
    include_directories(lms7suiteEvents)
    include_directories(boards_wxgui)
    include(${wxWidgets_USE_FILE})
    add_subdirectory(oglGraph)

    set(BINARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

    add_executable(LimeSuiteGUI ${LMS7SUITE_GUI_SOURCES} resources/resource.rc)
    set_target_properties(LimeSuiteGUI PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BINARY_OUTPUT_DIR})
    target_link_libraries(LimeSuiteGUI LimeSuite oglGraph ${wxWidgets_LIBRARIES})

    if (MSVC)
        set_property(TARGET LimeSuiteGUI APPEND PROPERTY LINK_FLAGS /SUBSYSTEM:WINDOWS)
    endif(MSVC)

    install(TARGETS LimeSuiteGUI DESTINATION bin)

endif()

########################################################################
# Build pkg config file
########################################################################
if (ENABLE_HEADERS AND ENABLE_LIBRARY)
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/LimeSuite.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/LimeSuite.pc
@ONLY)

install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/LimeSuite.pc
    DESTINATION lib${LIB_SUFFIX}/pkgconfig
)
endif (ENABLE_HEADERS AND ENABLE_LIBRARY)

########################################################################
# boardEmulator -- creates serial port and imitates board communications
########################################################################
if(UNIX)
    add_executable(boardEmulator boardEmulator.cpp)
    target_link_libraries(boardEmulator LimeSuite)
endif()

#########################################################################
# utilities
#########################################################################
add_subdirectory(utilities)

#########################################################################
# tests
#########################################################################
add_subdirectory(tests)

#########################################################################
# examples
#########################################################################
add_subdirectory(examples)

=== src/tests/CMakeLists.txt ===
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_TESTS "Enable library test programs" OFF "ENABLE_LIBRARY" OFF)

if (NOT ENABLE_TESTS)
    return()
endif()

find_package(Threads REQUIRED)
include(ExternalProject)
# Download and install GoogleTest
ExternalProject_Add(
    gtest
    URL https://github.com/google/googletest/archive/release-1.8.0.zip
    PREFIX ${CMAKE_CURRENT_BINARY_DIR}
    # Disable install step
    INSTALL_COMMAND ""
)

add_library(libgtest IMPORTED STATIC GLOBAL)
add_dependencies(libgtest gtest)

# Set gtest properties
ExternalProject_Get_Property(gtest source_dir binary_dir)
set_target_properties(libgtest PROPERTIES
    "IMPORTED_LOCATION" "${binary_dir}/googlemock/gtest/libgtest.a"
    "IMPORTED_LINK_INTERFACE_LIBRARIES" "${CMAKE_THREAD_LIBS_INIT}"
)
include_directories("${source_dir}/googletest/include")

add_executable(tests 
    main.cpp
    streaming.cpp
    comms.cpp
)

target_link_libraries(tests
    libgtest
    LimeSuite
)

add_dependencies(tests LimeSuite)

=== debian/changelog ===
limesuite (18.06.0+dfsg-1) unstable; urgency=medium

  * New upstream release 18.06.0
  * Change liblimesuite ABI version from 18.04-1 to 18.06-1
  * Bump Standards-Version to 4.1.5, no changes required

 -- Andreas Bombe <aeb@debian.org>  Sat, 28 Jul 2018 16:23:15 +0800

=== debian/control ===
Source: limesuite
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper (>= 11),
               cmake,
               pkg-config,
               doxygen,
               libusb-1.0-0-dev,
               libwxgtk3.0-dev,
               libsoapysdr0.6-dev,
               freeglut3-dev,
               libglew-dev,
               libfltk1.3-dev,
Standards-Version: 4.1.5
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Browser: https://salsa.debian.org/debian-hamradio-team/limesuite
Vcs-Git: https://salsa.debian.org/debian-hamradio-team/limesuite.git

Package: limesuite
Architecture: any
Depends: liblimesuite18.06-1 (>= ${binary:Version}),
         python, python-soapysdr,
         ${shlibs:Depends}, ${misc:Depends}
Description: tools to test, control and update LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the command line and GUI tools to control and update the
 hardware devices.

Package: liblimesuite18.06-1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev [linux-any]
Description: library to access LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the shared library to access LMS7 based hardware.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: liblimesuite18.06-1 (= ${binary:Version}),
         ${misc:Depends}
Suggests: liblimesuite-doc
Description: library to access LMS7 transceiver based hardware (development)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development files for liblimesuite.

Package: liblimesuite-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: liblimesuite development documentation
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development documentation for liblimesuite.

Package: soapysdr0.6-module-lms7
Architecture: any
Multi-Arch: same
Depends: liblimesuite18.06-1 (>= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains a SoapySDR module to use LMS7 based hardware to transmit
 and receive.

Package: soapysdr-module-lms7
Architecture: any
Multi-Arch: same
Depends: soapysdr0.6-module-lms7, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR (default version)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This is an ampty dependency package that pulls in the LMS7 support module for
 the default version of libsoapysdr.

Package: limesuite-udev
Section: libs
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Lime Suite - USB rules for udev
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the udev rules to make LMS7 based hardware accessible to
 users in the plugdev group.

## limesuite 18.10.0

=== debian/changelog ===
limesuite (18.10.0-1) unstable; urgency=low

  * Release 18.10.0 (2018-10-04)

 -- Lime Microsystems <info@limemicro.com> Thu, 04 Oct 2018 13:00:00 +0300

limesuite (18.06.0-1) unstable; urgency=low

  * Release 18.06.0 (2018-06-13)

 -- Lime Microsystems <info@limemicro.com>  Wed, 13 Jun 2018 15:00:00 +0300

limesuite (18.04.1-1) unstable; urgency=low

  * Release 18.04.1 (2018-04-19)

 -- Lime Microsystems <info@limemicro.com>  Thu, 19 Apr 2018 10:00:00 +0300

limesuite (18.04.0-1) unstable; urgency=low

  * Release 18.04.0 (2018-04-06)

 -- Lime Microsystems <info@limemicro.com>  Fri, 06 Apr 2018 14:30:00 +0300

limesuite (18.03.0-1) unstable; urgency=low

  * Release 18.03.0 (2018-03-28)

 -- Lime Microsystems <info@limemicro.com>  Wed, 28 Mar 2018 12:30:00 +0300

limesuite (17.12.0-1) unstable; urgency=low

  * Release 17.12.0 (2017-12-04)

 -- Lime Microsystems <info@limemicro.com>  Mon, 04 Dec 2017 12:50:00 +0300

limesuite (17.10.0-1) unstable; urgency=low

  * Release 17.10.0 (2017-10-19)

 -- Lime Microsystems <info@limemicro.com>  Thu, 19 Oct 2017 10:53:31 +0300

limesuite (17.09.1-1) unstable; urgency=low

  * Release 17.09.1 (2017-09-21)

 -- Lime Microsystems <info@limemicro.com>  Fri, 01 Sep 2017 15:43:31 +0300

limesuite (17.09.0-1) unstable; urgency=low

  * Release 17.09.0 (2017-09-01)

 -- Lime Microsystems <info@limemicro.com>  Fri, 01 Sep 2017 13:03:31 +0300

limesuite (17.06.0-1) unstable; urgency=low

  * Release 17.06.0 (2017-06-20)

 -- Lime Microsystems <info@limemicro.com>  Tue, 20 Jun 2017 20:51:09 -0500

limesuite (17.02.2-1) unstable; urgency=low

  * Release 17.02.2 (2017-04-30)
  * Switch to SoapySDR module ABI 0.6

 -- Lime Microsystems <info@limemicro.com>  Sun, 30 Apr 2017 00:10:38 -0700

limesuite (17.02.1-1) unstable; urgency=low

  * Release 17.02.1 (2017-03-11)
  * Fix debian packaging for 17.02 ABI

 -- Lime Microsystems <info@limemicro.com>  Sat, 11 Mar 2017 15:36:30 -0800

limesuite (17.02.0-1) unstable; urgency=low

  * Release 17.02.0 (2017-03-07)

 -- Lime Microsystems <info@limemicro.com>  Tue, 07 Mar 2017 12:57:30 -0800

limesuite (17.01.1-1) unstable; urgency=low

  * Release 17.01.1 (2017-02-03)

 -- Lime Microsystems <info@limemicro.com>  Fri, 03 Feb 2017 19:20:52 -0800

limesuite (17.01.0-1) unstable; urgency=low

  * Release 17.01.0 (2017-01-22)

 -- Lime Microsystems <info@limemicro.com>  Sun, 22 Jan 2017 13:06:52 -0800

limesuite (16.12.1-1) unstable; urgency=low

  * Release 16.12.1 (2017-01-22)

 -- Lime Microsystems <info@limemicro.com>  Sun, 22 Jan 2017 10:50:11 -0800

limesuite (16.12.0-1) unstable; urgency=low

  * updated debian packaging for 16.12.0 release

 -- Lime Microsystems <info@limemicro.com>  Fri, 30 Dec 2016 00:36:51 -0800

limesuite (16.8.1.819) unstable; urgency=low

  * updated debian packaging for latest version.h
  * set standards version to 3.9.7
  * update ABI version to 16.8-1
  * disable CMAKE_INSTALL_RPATH

 -- Lime Microsystems <info@limemicro.com>  Thu, 25 Aug 2016 11:41:35 -0700

limesuite (16.6.6.818) unstable; urgency=low

  * updated debian packaging for latest version.h

 -- Lime Microsystems <info@limemicro.com>  Sun, 26 Jun 2016 09:24:35 -0700

limesuite (16.5.12.816) unstable; urgency=low

  * debian packaging work for lime suite

 -- Lime Microsystems <info@limemicro.com>  Wed, 18 May 2016 18:18:06 -0700

=== debian/control ===
Source: limesuite
Section: comm
Priority: optional
Maintainer: Lime Microsystems <info@limemicro.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 3.1.3),
    libusb-1.0-0-dev,
    libwxgtk3.0-dev,
    libsoapysdr-dev,
    freeglut3-dev,
    libfltk1.3-dev,
    fluid,
Standards-Version: 4.1.1
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Git: https://github.com/myriadrf/LimeSuite.git
Vcs-Browser: https://github.com/myriadrf/LimeSuite.git

Package: liblimesuite18.10-1
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev, limesuite-images
Description: Lime Suite - shared library
 Lime Suite application software.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Depends:
    liblimesuite18.10-1 (= ${binary:Version}),
    ${misc:Depends}
Description: Lime Suite - development files
 Lime Suite application software.

Package: limesuite
Section: comm
Architecture: any
Depends:
    liblimesuite18.10-1 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends},
    xdg-utils
Description: Lime Suite - Library applications
 Lime Suite application software.

Package: soapysdr-module-lms7
Section: libs
Architecture: all
Pre-Depends: ${misc:Pre-Depends}
Depends: soapysdr0.6-module-lms7, ${misc:Depends}
Description: Lime Suite - SoapySDR bindings metapackage
 Lime Suite application software.

Package: soapysdr0.6-module-lms7
Section: comm
Architecture: any
Multi-Arch: same
Depends:
    liblimesuite18.10-1 (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Description: Lime Suite - SoapySDR bindings
 Lime Suite application software.

Package: limesuite-udev
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Description: Lime Suite - USB rules for udev
 Lime Suite application software.

Package: limesuite-images18.10
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, wget
Description: Lime Suite - Install firmware and gateware images
 Lime Suite application software.
 .
 This is dummy package that downloads the images from the web.

Package: limesuite-images
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images18.10
Description: Lime Suite - Install firmware and gateware images
 Lime Suite application software.
 .
 This is an empty dependency package that pulls in the images
 for the default version of Lime Suite.

## limesuite 19.04.0

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -69,6 +69,9 @@
     API/qLimeSDR.cpp
     API/LimeSDR_mini.cpp
     API/LimeSDR.cpp
+    API/LimeNET_micro.cpp
+    API/LimeSDR_PCIE.cpp
+    API/LimeSDR_Core.cpp
     FPGA_common/FPGA_common.cpp
     FPGA_common/FPGA_Mini.cpp
     FPGA_common/FPGA_Q.cpp
@@ -142,9 +145,11 @@
 include(ConnectionEVB7COM/CMakeLists.txt)
 include(ConnectionFX3/CMakeLists.txt)
 include(ConnectionSTREAM_UNITE/CMakeLists.txt)
-#include(ConnectionNovenaRF7/CMakeLists.txt)
+#include(ConnectionNovenaRF7/CMakeLists.txt)	#No longer supported
 include(ConnectionFTDI/CMakeLists.txt)
 include(ConnectionXillybus/CMakeLists.txt)
+include(ConnectionRemote/CMakeLists.txt)
+include(ConnectionSPI/CMakeLists.txt)
 
 configure_file(
     ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRegistry/BuiltinConnections.in.cpp
@@ -223,9 +228,12 @@
     boards_wxgui/pnluLimeSDR.cpp
     boards_wxgui/pnlUltimateEVB.cpp
     boards_wxgui/pnlBuffers.cpp
+    boards_wxgui/pnlCoreSDR.cpp
+    boards_wxgui/pnlLimeNetMicro.cpp
     ${PROJECT_SOURCE_DIR}/external/kissFFT/kiss_fft.c
     windowFunction.cpp
     boards_wxgui/pnlLimeSDR.cpp
+    boards_wxgui/pnlGPIO.cpp
 )
 
 include(FeatureSummary)
@@ -291,11 +299,6 @@
 add_subdirectory(utilities)
 
 #########################################################################
-# tests
-#########################################################################
-add_subdirectory(tests)
-
-#########################################################################
 # examples
 #########################################################################
 add_subdirectory(examples)

## limesuite 20.01.0

=== debian/control ===
--- 
+++ 
@@ -16,12 +16,12 @@
 Vcs-Git: https://github.com/myriadrf/LimeSuite.git
 Vcs-Browser: https://github.com/myriadrf/LimeSuite.git
 
-Package: liblimesuite18.10-1
+Package: liblimesuite20.01-1
 Section: libs
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: osmocom-latest, ${shlibs:Depends}, ${misc:Depends}
 Recommends: limesuite-udev, limesuite-images
 Description: Lime Suite - shared library
  Lime Suite application software.
@@ -30,7 +30,7 @@
 Section: libdevel
 Architecture: any
 Depends:
-    liblimesuite18.10-1 (= ${binary:Version}),
+    liblimesuite20.01-1 (= ${binary:Version}),
     ${misc:Depends}
 Description: Lime Suite - development files
  Lime Suite application software.
@@ -39,7 +39,7 @@
 Section: comm
 Architecture: any
 Depends:
-    liblimesuite18.10-1 (= ${binary:Version}),
+    liblimesuite20.01-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends},
     xdg-utils
@@ -50,16 +50,16 @@
 Section: libs
 Architecture: all
 Pre-Depends: ${misc:Pre-Depends}
-Depends: soapysdr0.6-module-lms7, ${misc:Depends}
+Depends: osmocom-latest, soapysdr0.7-module-lms7, ${misc:Depends}
 Description: Lime Suite - SoapySDR bindings metapackage
  Lime Suite application software.
 
-Package: soapysdr0.6-module-lms7
+Package: soapysdr0.7-module-lms7
 Section: comm
 Architecture: any
 Multi-Arch: same
 Depends:
-    liblimesuite18.10-1 (= ${binary:Version}),
+    liblimesuite20.01-1 (= ${binary:Version}),
     ${shlibs:Depends},
     ${misc:Depends}
 Description: Lime Suite - SoapySDR bindings
@@ -69,15 +69,15 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, udev
+Depends: osmocom-latest, ${shlibs:Depends}, ${misc:Depends}, udev
 Description: Lime Suite - USB rules for udev
  Lime Suite application software.
 
-Package: limesuite-images18.10
+Package: limesuite-images20.01
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, wget
+Depends: osmocom-latest, ${shlibs:Depends}, ${misc:Depends}, wget
 Description: Lime Suite - Install firmware and gateware images
  Lime Suite application software.
  .
@@ -87,7 +87,7 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}, limesuite-images18.10
+Depends: osmocom-latest, ${shlibs:Depends}, ${misc:Depends}, limesuite-images20.01
 Description: Lime Suite - Install firmware and gateware images
  Lime Suite application software.
  .
